//***************************************************************************
//
//  ̧......: ADC.c
//  ......: ATMEL Norway
//  ړIΏ..: ATmega169
//  ߲....: IAR EWAAVR 2.28a
//  ......: AVR Butterfly ADCٰ
//  ......: 1.0
//
//  N   -   - 											- 
//  20030116 - 1.0 - 쐬											- LHM
//
//***************************************************************************

#include <inavr.h>
#include "iom169.h"
#include "main.h"
#include "ADC.h"
#include "BCD.h"
#include "LCD_functions.h"
#include "Timer0.h"

__flash int TEMP_Celcius_pos[] =	// ێ+x\ (A/DϊlƔr:0`60)
		{
		  806,796,786,775,765,754,743,732,720,709,697,685,673,661,649,
		  636,624,611,599,586,574,562,549,537,524,512,500,488,476,464,
		  452,440,429,418,406,396,385,374,364,354,344,334,324,315,306,
		  297,288,279,271,263,255,247,240,233,225,219,212,205,199,193,
		  187,
		};

__flash int TEMP_Celcius_neg[] =	// ێ-x\ (A/DϊlƔr:-1`-15)
		{
		  815,825,834,843,851,860,868,876,883,891,898,904,911,917,923,
		};

__flash int TEMP_Farenheit_pos[] =	// ؎-x\ (A/DϊlƔr:0`140)
		{
		  938, 935, 932, 929, 926, 923, 920, 916, 913, 909, 906, 902, 898, 
		  894, 891, 887, 882, 878, 874, 870, 865, 861, 856, 851, 847, 842, 
		  837, 832, 827, 822, 816, 811, 806, 800, 795, 789, 783, 778, 772, 
		  766, 760, 754, 748, 742, 735, 729, 723, 716, 710, 703, 697, 690, 
		  684, 677, 670, 663, 657, 650, 643, 636, 629, 622, 616, 609, 602, 
		  595, 588, 581, 574, 567, 560, 553, 546, 539, 533, 526, 519, 512, 
		  505, 498, 492, 485, 478, 472, 465, 459, 452, 446, 439, 433, 426, 
		  420, 414, 408, 402, 396, 390, 384, 378, 372, 366, 360, 355, 349, 
		  344, 338, 333, 327, 322, 317, 312, 307, 302, 297, 292, 287, 282, 
		  277, 273, 268, 264, 259, 255, 251, 246, 242, 238, 234, 230, 226, 
		  222, 219, 215, 211, 207, 204, 200, 197, 194, 190, 187, 
		};

__flash int LIGHT_ADC[] =		// AREF␳px\ (A/DϊlƔr:邳łAREFω̂߁Adǂݎ莞ɌxAREFl␳)
		{
		53,96,128,176,285,317,346,378,407,441,474,505,534,576,621,642,674,751,818,944,1010
		};

__flash float LIGHT_VOLTAGE[] =	// AREFd\ (Px`:\ɑΉAREFd(V))
		{
		2.818,2.820,2.824,2.827,2.832,2.835,2.839,2.841,2.843,2.847,2.850,2.853,2.857,2.863,2.867,2.870,2.874,2.882,2.893,2.917,2.939
		};

float Vref = 2.900;				// AREFd
char degree = CELCIUS;			// ێx/؎xԍ(l=ێx)

//*****************************************************************************
//*
//* ֐	: ADC_init
//* 	: char input(A/Dϊٔԍ)
//* Ԃl	: Ȃ
//* ړI	: IA/DϊقA/Dϊ평
//*
//*****************************************************************************
void ADC_init(char input)
{
  ADMUX = input;									// OAREFd,wA/Dِݒ
  ADCSRA = (1<<ADEN) | (1<<ADPS1) | (1<<ADPS0);		// 8Ou(1MHz/8=125kHz)A/Dϊ틖
  input = ADC_read();								// ̑̂߂̎A/Dϊǂ݂
}

//*****************************************************************************
//*
//* ֐	: ADC_read
//* 	: Ȃ
//* Ԃl	: int ADC(A/Dϊl)
//* ړI	: A/Dϊsƕϊl擾
//*
//*****************************************************************************
int ADC_read(void)
{
  char i;						// Ɨp
  int ADC_temp;					// ڂA/Dϊl
  int ADC = 0;					// ϗpώZlƌʂA/Dϊl

  // ߓd̂߂Ɍmƻнւ̓d͖gpOFF܂B
  // PF3o݂̓d𐧌䂷邱ƂɂčsȂ܂B
  sbi(PORTF, PORTF3);			// m֌Wd(VCP)(PF3=H)
  sbi(DDRF, PORTF3);			// PF3o͐ݒ
  sbi(ADCSRA, ADEN);			// A/Dϊ퓮싖
  ADCSRA |= (1<<ADSC);			// PƕϊJn(艻̂߂̏̂ĕϊ)
  while(!(ADCSRA & 0x10));		// ϊ(ADIF=1)܂őҋ@

  for(i=0;i<8;i++)				/* ǂx̂߂8ϊAɕω */
  {
	ADCSRA |= (1<<ADSC);		// PƕϊJn
	while(!(ADCSRA & 0x10));	// ϊ(ADIF=1)܂őҋ@
	ADC_temp = ADCL;			// A/Dϊlʎ擾
	ADC_temp += (ADCH << 8);	// A/Dϊlʎ擾,l
	ADC += ADC_temp;			// ϊlώZ(̕ωp)
  }
  ADC = ADC >> 3;				// 8񕪂̕ϒl擾

  cbi(PORTF, PORTF3);			// m֌Wd(VCP)֎~(PF3=L)
  cbi(DDRF, PORTF3);			// PF3͐ݒ
  cbi(ADCSRA, ADEN);			// (ߓd̂)A/Dϊ퓮֎~
  return ADC;					// A/DϊlƋɕA
}

//*****************************************************************************
//*
//* ֐	: ADC_periphery
//* 	: Ȃ
//* Ԃl	: Ȃ
//* ړI	: A/Dϊl擾,x/d/xvZLCDޯ̧ݒ
//*
//*****************************************************************************
void ADC_periphery(void)
{
  int ADCresult = 0;								// A/Dϊ擾l
  int ADCresult_temp = 0;							// 擾ςݓdA/Dϊlۑp
  int Temp_int;										// 3lBCDϊlۑp
  char Temp;										// 2lBCDϊlۑp,̑
  unsigned char i = 0;								// Ɨp
  char TL;											// ʗp
  char TH;											// ʗp
  char VL;											// _ȉ1p
  float V_ADC;										// AREF̓dlvZp
  char VoltageHB;									// dl
  char VoltageLB;									// dl

  ADCresult = ADC_read();							// ΉA/Dϊ,A/Dϊl擾
  if( ADMUX == TEMPERATURE_SENSOR )					/* x莞 */
  {
	if(degree == CELCIUS)							/* (ێx) */
	{
	  if(ADCresult > 810)							/* ((-x)) */
	  {
		for (i=0; i<=25; i++)						/* (((-xr))) */
		{
		  if (ADCresult <= TEMP_Celcius_neg[i])		// ΉlȉŔrI(i=Ȃx)
		  {
			break;
		  }
		}

		LCD_putc(1, '-');							// LCDޯ̧2ڂ-ݒ
	  }
	  else if (ADCresult < 800)						/* ((+x)) */
	  {
		for (i=0; i<100; i++)						/* (((+xr))) */
		{
		  if (ADCresult >= TEMP_Celcius_pos[i])		// ΉlȏŔrI(i=Ȃx)
		  {
			break;
		  }
		}
		LCD_putc(1, '+');							// LCDޯ̧2ڂ+ݒ
	  }
	  else											/* ((0)) */
	  {
		i = 0;										// x=0w
		LCD_putc(1, ' ');							// LCDޯ̧2ڂɋ󔒕ݒ
	  }
	  Temp = CHAR2BCD2(i);							// xl2lBCDϊ
	  TL = (Temp & 0x0F) + '0';						// x1̌擾
	  TH = (Temp >> 4) + '0';						// x10̌擾
	  LCD_putc(0, ' ');								// LCDޯ̧1ڂɋ󔒕ݒ
	  // : LCD2ڂ͊ɐݒς
	  LCD_putc(2, TH);								// LCDޯ̧3ڂɉx10̌ݒ
	  LCD_putc(3, TL);								// LCDޯ̧4ڂɉx1̌ݒ
	  LCD_putc(4, '*');								// LCDޯ̧5ڂ(o)ݒ
	  LCD_putc(5, 'C');								// LCDޯ̧6ڂ'C'ݒ
	  LCD_putc(6, '\0');							// LCDޯ̧7ڂɏIqݒ
	}
	else if (degree == FARENHEIT)					/* (؎x) */
	{
	  for (i=0; i<=141; i++)						/* ((xr)) */
	  {
		if (ADCresult > TEMP_Farenheit_pos[i])		// ΉlzŔrI(i=Ȃx)
		{
		  break;
		}
	  }
	  Temp_int = CHAR2BCD3(i);						// xl3lBCDϊ
	  if (i > 99)									/* ((3)) */
	  {
		LCD_putc(0, '+');							// LCDޯ̧1ڂ+ݒ
		TH = (Temp_int >> 8) + '0';					// x100̌擾
		LCD_putc(1, TH);							// LCDޯ̧2ڂɉx100̌ݒ
	  }
	  else											/* ((2)) */
	  {
		LCD_putc(0, ' ');							// LCDޯ̧1ڂɋ󔒕ݒ
		LCD_putc(1, '+');							// LCDޯ̧2ڂ+ݒ
	  }
	  TL = (Temp_int & 0x0F) + '0';					// x1̌擾
	  TH = ( (Temp_int >> 4) & 0x0F ) + '0';		// x10̌擾
	  LCD_putc(2, TH);								// LCDޯ̧3ڂɉx10̌ݒ
	  LCD_putc(3, TL);								// LCDޯ̧4ڂɉx1̌ݒ
	  LCD_putc(4, '*');								// LCDޯ̧5ڂ(o)ݒ
	  LCD_putc(5, 'F');								// LCDޯ̧6ڂ'F'ݒ
	  LCD_putc(6, '\0');							// LCDޯ̧7ڂɏIqݒ
	}
	// : LCD\XV(LCD_UpdateRequired = TRUE)sȂ܂B
	//     ͖{A/DϊNo^(/0荞ݖɎs)sōsȂ܂B
  }
  else if( ADMUX == VOLTAGE_SENSOR )				/* d莞 */
  {
	// ݻAREFɉe^邽߁AAREF߂OɌxs܂B
	ADCresult_temp = ADCresult;						// dA/Dϊlۑ
	ADC_init(LIGHT_SENSOR);							// xA/Dϊ
	ADCresult = ADC_read();							// xA/Dϊl擾
	for (i=0; i<=22; i++)							/* (xr) */
	{
	  if (ADCresult <= LIGHT_ADC[i])				// ΉlȉŔrI
	  {
		break;
	  }
	}
	if(!i)											// ɖ邢ȂAAREF=2.815V
	  Vref = 2.815;
	else if(i > 21)									// IɈÂȂAAREF=2.942V
	  Vref = 2.942;
	else											// Ȃ΁A
	  Vref = LIGHT_VOLTAGE[i];						// Ή\AREFdl擾

	ADMUX = VOLTAGE_SENSOR;							// dA/DϊĎw
	ADCresult = ADCresult_temp;						// dA/DϊlA
	// ȍ~A߂AREFd̓d菈
	V_ADC = ( ADCresult * Vref ) / 1024;			// PɑdvZ
	V_ADC = ( V_ADC * 6 );							// 1/6̂6{
	VoltageHB = V_ADC;								// dl擾
	V_ADC = ( V_ADC - VoltageHB );					// dl̂ݎ擾
	VoltageLB = ( V_ADC * 100 );					// 10ił2lAlƂĎ擾
	Temp = CHAR2BCD2(VoltageHB);					// 2lBCDϊ
	TL = (Temp & 0x0F) + '0';						// 1̌擾
	TH = (Temp >> 4) + '0';							// 10̌擾
	Temp = CHAR2BCD2(VoltageLB);					// 2lBCDϊ
	VL = (Temp >> 4) + '0';							// ȉ1ʌ擾
	LCD_putc(0, ' ');								// LCDޯ̧1ڂɋ󔒕ݒ
	LCD_putc(1, ' ');								// LCDޯ̧2ڂɋ󔒕ݒ
	LCD_putc(2, ' ');								// LCDޯ̧3ڂɋ󔒕ݒ
	LCD_putc(3, TL);								// LCDޯ̧4ڂɐ1̌ݒ
	LCD_putc(4, 'V');								// LCDޯ̧5ڂ'V'ݒ
	LCD_putc(5, VL);								// LCDޯ̧6ڂɏȉ1ʌݒ
	LCD_putc(6, '\0');								// LCDޯ̧7ڂɏIqݒ
	// : LCD\XV(LCD_UpdateRequired = TRUE)sȂ܂B
	//     ͖{A/DϊNo^(/0荞ݖɎs)sōsȂ܂B
  }
  else if( ADMUX == LIGHT_SENSOR )					/* x莞 */
  {
	// A/DϊlluxԂ̊֌W͖ꂸAA/DϊlLCDɕ\܂B
	VoltageHB = CHAR2BCD2(ADCH);					// A/Dϊlʂ2߯BCDϊ
	Temp = ADCL;									// A/Dϊlʎ擾
	TL = (Temp & 0x0F) + '0';						// A/Dϊlŉق()ϊ
	if(TL > '9')									// '9'z'A'(16i)ϊ
	  TL += 7;
	TH = (Temp >> 4) + '0';							// A/Dϊl2ق()ϊ
	if(TH > '9')									// '9'z'A'(16i)ϊ
	  TH += 7;
	LCD_putc(0, 'A');								// LCDޯ̧1ڂ'A'ݒ
	LCD_putc(1, 'D');								// LCDޯ̧2ڂ'D'ݒ
	LCD_putc(2, 'C');								// LCDޯ̧3ڂ'C'ݒ
	LCD_putc(3, (ADCH + 0x30));						// LCDޯ̧4ڂA/Dϊlŏِݒ
	LCD_putc(4, TH);								// LCDޯ̧5ڂA/Dϊl2ِݒ
	LCD_putc(5, TL);								// LCDޯ̧6ڂA/Dϊlŉِݒ
	LCD_putc(6, '\0');								// LCDޯ̧7ڂɏIqݒ
	// : LCD\XV(LCD_UpdateRequired = TRUE)sȂ܂B
	//     ͖{A/DϊNo^(/0荞ݖɎs)sōsȂ܂B
  }
}

//*****************************************************************************
//*
//* ֐	: TemperatureFunc
//* 	: char input (ޮèԔԍ)
//* Ԃl	: char ST_state (S̏Ԕԍ)
//* ړI	: x̋/֎~
//*
//*****************************************************************************
char TemperatureFunc(char input)
{
  static char enter = 1;								// ׸

  if (enter)											/* 񎞏 */
  {
	enter = 0;											// ׸މ
	ADC_init(TEMPERATURE_SENSOR);						// xA/Dϊ
	Timer0_RegisterCallbackFunction(ADC_periphery);		// A/Dϊso^(Jn)
	// s͖10msɎs(ۂɂͽذ߂̕Â߂10msȏ)
  }
  else													/* ȊO */
	LCD_UpdateRequired(TRUE, 0);						// LCD\XV(\e͎sŐݒς)
  if (input == KEY_PREV)								/* (ޮè) */
  {
	Timer0_RemoveCallbackFunction(ADC_periphery);		// A/Dϊs폜(~)
	enter = 1;											// ׸ސݒ(ڍsp)
	return ST_TEMPERATURE;								// xƭԔԍƋɕA
  }
  else if (input == KEY_PLUS)							/* (ޮè) */
  {
	if (degree == FARENHEIT)							// ݉؎xwȂAێxwɕύX
	  degree = CELCIUS;
	else												// ݐێxwȂA؎xwɕύX
	  degree = FARENHEIT;
  }
  else if (input == KEY_MINUS)							/* (ޮè) */
  {
	if (degree == FARENHEIT)							// ݉؎xwȂAێxwɕύX
	  degree = CELCIUS;
	else												// ݐێxwȂA؎xwɕύX
	  degree = FARENHEIT;
  }
  return ST_TEMPERATURE_FUNC;							// xԔԍƋɕA
}

//*****************************************************************************
//*
//* ֐	: VoltageFunc
//* 	: char input (ޮèԔԍ)
//* Ԃl	: char ST_state (S̏Ԕԍ)
//* ړI	: d̋/֎~
//*
//*****************************************************************************
char VoltageFunc(char input)
{
  static char enter = 1;								// ׸

  if (enter)											/* 񎞏 */
  {
	enter = 0;											// ׸މ
	ADC_init(VOLTAGE_SENSOR);							// dA/Dϊ
	Timer0_RegisterCallbackFunction(ADC_periphery);		// A/Dϊso^(Jn)
	// s͖10msɎs(ۂɂͽذ߂̕Â߂10msȏ)
  }
  else													/* ȊO */
	LCD_UpdateRequired(TRUE, 0);						// LCD\XV(\e͎sŐݒς)
  if (input == KEY_PREV)								/* (ޮè) */
  {
	Timer0_RemoveCallbackFunction(ADC_periphery);		// A/Dϊs폜(~)
	enter = 1;											// ׸ސݒ(ڍsp)
	return ST_VOLTAGE;									// dƭԔԍƋɕA
  }
  else													/* (ޮèȊO) */
	return ST_VOLTAGE_FUNC;								// dԔԍƋɕA
}

//*****************************************************************************
//*
//* ֐	: LightFunc
//* 	: char input (ޮèԔԍ)
//* Ԃl	: char ST_state (S̏Ԕԍ)
//* ړI	: x̋/֎~
//*
//*****************************************************************************
char LightFunc(char input)
{
  static char enter = 1;								// ׸

  if (enter)											/* 񎞏 */
  {
	enter = 0;											// ׸މ
	ADC_init(LIGHT_SENSOR);								// xA/Dϊ
	Timer0_RegisterCallbackFunction(ADC_periphery);		// A/Dϊso^(Jn)
	// s͖10msɎs(ۂɂͽذ߂̕Â߂10msȏ)
  }
  else													/* ȊO */
	LCD_UpdateRequired(TRUE, 0);						// LCD\XV(\e͎sŐݒς)
  if (input == KEY_PREV)								/* (ޮè) */
  {
	Timer0_RemoveCallbackFunction(ADC_periphery);		// A/Dϊs폜(~)
	enter = 1;											// ׸ސݒ(ڍsp)
	return ST_LIGHT;									// xƭԔԍƋɕA
  }
  else													/* (ޮèȊO) */
	return ST_LIGHT_FUNC;								// xԔԍƋɕA
}
